#include <conio.h>
#include <stdio.h>

#include "rpg.h"
#include "advinput.h"

int curType;
byte Color[NUM_BATTLES];
char Name[NUM_BATTLES][9];
paletteType palette;
battleType battleData[NUM_BATTLES];

int main(void)
{
  FILE *handle;
  handle = fopen("b_info.dat", "rb");
  if (handle)
  {
    fread(Color, 1, NUM_BATTLES, handle);
    fread(Name, 9, NUM_BATTLES, handle);
    fclose(handle);
  }

  handle = fopen(BTYPE_FILE, "rb");
  if (handle)
  {
    fread(battleData, 1, NUM_BATTLES * sizeof(battleType), handle);
    fclose(handle);
  }

  clrscr();
  textcolor(YELLOW);
  cprintf("Battle Type Editor\n\r"
          "v1.0\n\n\r"
          "Chad Austin 1997\n\n\r");
  if (getch() == 0) getch();

  char c;

  if (loadPalette("GAME_PAL.PAL", palette))
  {
    textcolor(7);
    clrscr();
    cputs("Error: Could not open palette file (GAME_PAL.PAL)\n\r");
    return 1;
  }

  int done = 0;
  while (!done)
  {
    clrscr();
    textcolor(LIGHTGREEN);
    cprintf("Current Battle Type: %d\n\n\r", curType);
    cprintf("Color: %d\n\r", Color[curType]);
    cprintf("Name: %s\n\r", Name[curType]);
    cprintf("Percent: %d\n\r", battleData[curType].percent);
    
    int x;
    cprintf("Number of monsters: %d\n\r", battleData[curType].numMonsters);
    for (x = 0; x < battleData[curType].numMonsters; x++)
    {
      if (x % 2) gotoxy(41, x / 2 + 7); else gotoxy(1, x / 2 + 7);
      textcolor(LIGHTRED);
      cprintf("%2d  ", x + 1);
      textcolor(YELLOW);
      cprintf("%d", battleData[curType].monster[x]);
    }
    cputs("\n\n\r");

    textcolor(LIGHTCYAN);
    cputs("<  Prev Type           >  Next Type\n\r"
          "C  Edit Color          V  View Color\n\r"
          "N  Edit Name           M  Number of monsters\n\r"
          "E  Edit Monster        P  Change Percent\n\r"
          "S  Save                Q  Quit\n\n\r");

    c = getch();
    switch (c)
    {
      case 0: getch(); break;
      case ',': case '<': if (--curType == -1) curType = NUM_BATTLES - 1;
                          break;
      case '.': case '>': if (++curType == NUM_BATTLES) curType = 0;
                          break;
      case 'c': case 'C':
        Color[curType] = getint("Enter color: ", 0, 255); break;
      case 'v': case 'V':
        setvmode(0x13);
        setAllPalette(palette);
        clearScreen(Color[curType]);
        if (getch() == 0) getch();
        setvmode(0x3);
        break;

      case 'n': case 'N': getstring(Name[curType], "Enter name: ", 8); break;
      case 'm': case 'M':
        battleData[curType].numMonsters = getint("Enter number of monsters: ",
                                                 0, 16);
        break;

      case 'e': case 'E':
        if (battleData[curType].numMonsters)
        {
          int monster;
          monster = getint("Which monster: ", 1,
                           battleData[curType].numMonsters);
          monster--;
          cputs("\n\r");
          battleData[curType].monster[monster] =
            getint("Enter value: ", 1, NUM_MONSTERS) - 1;
          break;
        }

      case 'p': case 'P':
        battleData[curType].percent = getint("Enter new percent: ", 0, 100);
        break;

      case 's': case 'S':
        handle = fopen("b_info.dat", "wb");
        fwrite(Color, 1, NUM_BATTLES, handle);
        fwrite(Name, 9, NUM_BATTLES, handle);
        fclose(handle);

        handle = fopen(BTYPE_FILE, "wb");
        fwrite(battleData, 1, NUM_BATTLES * sizeof(battleType), handle);
        fclose(handle);
        break;

      case 'q': case 'Q': done = 1;
    }
  }

  textcolor(7);
  clrscr();

  return 0;
}
