#include <dos.h>
#include <conio.h>

typedef unsigned char byte;

#define KEY_INT     0x09
#define KEY_BUFFER  0x60
#define KEY_CONTROL 0x61
#define INT_CONTROL 0x20

void interrupt (far *oldKeyHandler)(...);

volatile byte rawKey;
volatile byte keyTable[128];

byte newInput;

void interrupt far newKeyHandler(...)
{
  asm
  {
    cli
    in al, KEY_BUFFER
    mov rawKey, al
    in al, KEY_CONTROL
    or al, 0x82
    out KEY_CONTROL, al
    and al, 0x7F
    out KEY_CONTROL, al
    mov al, 0x20
    out INT_CONTROL, al
  }
  
  if (rawKey < 128)
    keyTable[rawKey] = 1;
  else
    keyTable[rawKey - 128] = 0;
    
  asm sti
}

void initKeyboard(void)
{
  oldKeyHandler = getvect(KEY_INT);
  setvect(KEY_INT, newKeyHandler);
  newInput = 1;
}

void closeKeyboard(void)
{
  setvect(KEY_INT, oldKeyHandler);
  newInput = 0;
}

void main(void)
{
  initKeyboard();
  clrscr();
  cputs("Press any key...\n\r");

  byte done;
  int x;
  while (!done)
    for (x = 0; x < 128; x++)
      if (keyTable[x] && x != 42)
      {
        cprintf("Scan code: %d\n\r", x);
        done = 1;
        break;
      }

  closeKeyboard();
}
