#include "rpg.h"

char string[80];

#define items(x)    gamedata.items[x]
#define itemData(x) gamedata.itemData[x]
#define weapons(x)  gamedata.weapons[x]
#define shields(x)  gamedata.shields[x]
#define helmets(x)  gamedata.helmets[x]
#define mails(x)    gamedata.mails[x]

void showItems(int topItem)
{
  window(100, 8, 120, 104);
  blitString(102, 10, 15, "Items");

  int x;
  for (x = topItem; x < topItem + 10; x++)
  {
    int itemnum = items(x).num;
    string[0] = 0;
    switch (items(x).type)
    {
      case BLANK:  break;
      case ITEM:   strcpy(string, itemData(itemnum).name); break;
      case WEAPON: strcpy(string, weapons(itemnum).name);  break;
      case SHIELD: strcpy(string, shields(itemnum).name);  break;
      case HELMET: strcpy(string, helmets(itemnum).name);  break;
      case MAIL:   strcpy(string, mails(itemnum).name);    break;
    }
    blitString(116, (x - topItem) * 8 + 28, 15, string);
  }
}

void menu_items(void)
{
  showItems(0);
  blitImage(100, 24, &arrow);

  int topitem = 0, curitem = 0;

  int done = 0;
  while (!done)
  {
    int exec = 0;

    while (keyPressed()) {}
    int key = 0;
    while (!key)
    {
      if (keyTable[UPARROW])   { key = 1; if (--curitem == topitem - 1)
                                 if (--topitem == -1)
                                   { topitem++; curitem++; }
                                 PlaySound(SOUND_CHOICE);
                               }
      if (keyTable[DOWNARROW]) { key = 1; if (++curitem == topitem + 10)
                                 if (++topitem == NUM_ITEMS)
                                   { topitem--; curitem--; }
                                 PlaySound(SOUND_CHOICE);
                               }
      if (keyTable[ESC])       { key = 1; done = 1; PlaySound(SOUND_SELECT); }
      if (keyTable[ENTER])     { key = 1; exec = 1; PlaySound(SOUND_SELECT); }
    }

    if (exec)
    {
      if (items(curitem).type == ITEM)
      {
        int itemnum = items(curitem).num;
        player.HP += itemData(itemnum).HPup;
        if (player.HP > player.maxHP) player.HP = player.maxHP;
        player.MP += itemData(itemnum).MPup;
        if (player.MP > player.maxMP) player.MP = player.maxMP;
        items(curitem).type = BLANK;
      }
    }

    showItems(topitem);
    blitImage(100, (curitem - topitem) * 8 + 24, &arrow);
  }
}

enum { R_HAND, L_HAND, HEAD, BODY };

void unequip(int part)
{
#define noroom "No room"
#define NRW() { window(40, 40, strlen(noroom) * 8 + 4, 12);  \
                blitString(42, 42, 15, noroom);              \
                while (keyPressed())  {}                     \
                while (!keyPressed()) {} }

  switch (part)
  {
    case R_HAND:
      if (player.weapon != UNEQUIPPED)
      {
        if (additem(WEAPON, player.weapon)) { NRW(); }
        else player.weapon = UNEQUIPPED;
      } break;

    case L_HAND:
      if (player.shield != UNEQUIPPED)
      {
        if (additem(SHIELD, player.shield)) { NRW(); }
        else player.shield = UNEQUIPPED;
      } break;

    case HEAD:
      if (player.helmet != UNEQUIPPED)
      {
        if (additem(HELMET, player.helmet)) { NRW(); }
        else player.helmet = UNEQUIPPED;
      } break;

    case BODY:
      if (player.mail   != UNEQUIPPED)
      {
        if (additem(MAIL, player.mail)) { NRW(); }
        else player.mail = UNEQUIPPED;
      } break;
  }
}

void equip(int part)
{
  int part_type;

  switch (part)
  {
    case R_HAND: part_type = WEAPON; break;
    case L_HAND: part_type = SHIELD; break;
    case HEAD:   part_type = HELMET; break;
    case BODY:   part_type = MAIL;   break;
  }

  int itemList[NUM_ITEMS];
  int numberList[NUM_ITEMS];
  int itemchoice = 0, olditemchoice = 0;
  int numitems = 0;
  int select = 0;

  int x;
  for (x = 0; x < NUM_ITEMS; x++)
   if (gamedata.items[x].type == part_type)
     { itemList[numitems] = gamedata.items[x].num;
       numberList[numitems] = x; numitems++; }

  if (numitems)
  {
    for (x = 0; x < numitems && x < 5; x++)
    {
      switch (part)
      {
        case R_HAND: blitString(116, x * 8 + 80, 15, gamedata.weapons[itemList[x]].name); break;
        case L_HAND: blitString(116, x * 8 + 80, 15, gamedata.shields[itemList[x]].name); break;
        case HEAD:   blitString(116, x * 8 + 80, 15, gamedata.helmets[itemList[x]].name); break;
        case BODY:   blitString(116, x * 8 + 80, 15, gamedata.mails  [itemList[x]].name); break;
      }
    }

    itemchoice = 0;
    blitImage(100, 76, &arrow);

    int equipitem = 0;

    while (!select)
    {
      if (olditemchoice != itemchoice) PlaySound(SOUND_CHOICE);
      olditemchoice = itemchoice;

      while (keyPressed()) {}
      int key = 0;
      while (!key)
      {
        if (keyTable[UPARROW])
          { key = 1; if (--itemchoice == -1)
            itemchoice = 0; }
        if (keyTable[DOWNARROW])
          { key = 1; if (++itemchoice == numitems)
            itemchoice = numitems - 1; }
        if (keyTable[ENTER]) { key = 1; select = 1; equipitem = 1;
                               PlaySound(SOUND_SELECT); }
        if (keyTable[ESC])   { key = 1; select = 1; PlaySound(SOUND_SELECT); }
      }

      clearArea(100, olditemchoice * 8 + 76, 16, 16);
      blitImage(100, itemchoice * 8 + 76, &arrow);
    }

    clearArea(100, itemchoice * 8 + 76, 16, 16);

    if (equipitem)
    {
      unequip(part);

      switch (part)
      {
        case R_HAND: player.weapon = itemList[itemchoice]; break;
        case L_HAND: player.shield = itemList[itemchoice]; break;
        case HEAD:   player.helmet = itemList[itemchoice]; break;
        case BODY:   player.mail   = itemList[itemchoice]; break;
      }
      gamedata.items[numberList[itemchoice]].type = BLANK;
    }
  }
}

void showEquipped(void)
{
  window(100, 38, 178, 120);
  blitString(116, 42, 15, "R Hand:");
  blitString(116, 50, 15, "L Hand:");
  blitString(116, 58, 15, "Head:");
  blitString(116, 66, 15, "Body:");

#define EQUIP_X 116 + 8 * 8

  if (player.weapon != UNEQUIPPED)
    blitString(EQUIP_X, 42, 15, gamedata.weapons[player.weapon].name);
  if (player.shield != UNEQUIPPED)
    blitString(EQUIP_X, 50, 15, gamedata.shields[player.shield].name);
  if (player.helmet != UNEQUIPPED)
    blitString(EQUIP_X, 58, 15, gamedata.helmets[player.helmet].name);
  if (player.mail   != UNEQUIPPED)
    blitString(EQUIP_X, 66, 15, gamedata.mails  [player.mail]  .name);
}

void equip_part(void)
{
  int curchoice = 0, oldchoice = 0;

  blitImage(100, 38, &arrow);

  int done = 0;
  while (!done)
  {
    int exec = 0;
    if (oldchoice != curchoice) PlaySound(SOUND_CHOICE);
    oldchoice = curchoice;

    while (keyPressed()) {}
    int key = 0;
    while (!key)
    {
      if (keyTable[UPARROW])
        { key = 1; if (--curchoice == -1) curchoice = 3; }
      if (keyTable[DOWNARROW])
        { key = 1; if (++curchoice == 4)  curchoice = 0; }
      if (keyTable[ESC])       { key = 1; done = 1; PlaySound(SOUND_SELECT); }
      if (keyTable[ENTER])     { key = 1; exec = 1; PlaySound(SOUND_SELECT); }
    }

    clearArea(100, oldchoice * 8 + 38, 16, 16, 0);

	 if (exec)
    {
      switch (curchoice)
      {
        case 0: equip(R_HAND); break;
        case 1: equip(L_HAND); break;
        case 2: equip(HEAD);   break;
        case 3: equip(BODY);   break;
      }
      showEquipped();
    }

    showEquipped();
    blitImage(100, curchoice * 8 + 38, &arrow);
  }

  clearArea(100, curchoice * 8 + 38, 16, 16);
}

void unequip_part(void)
{
  int curchoice = 0, oldchoice = 0;

  blitImage(100, 38, &arrow);

  int done = 0;
  while (!done)
  {
    int exec = 0;
    oldchoice = curchoice;

    while (keyPressed()) {}
    int key = 0;
    while (!key)
    {
      if (keyTable[UPARROW])
        { key = 1; if (--curchoice == -1) curchoice = 3; }
      if (keyTable[DOWNARROW])
        { key = 1; if (++curchoice == 4)  curchoice = 0; }
      if (keyTable[ESC])       { key = 1; done = 1;      }
      if (keyTable[ENTER])     { key = 1; exec = 1;      }
    }

    clearArea(100, oldchoice * 8 + 38, 16, 16, 0);

	 if (exec)
	 {
		switch (curchoice)
		{
		  case 0: unequip(R_HAND); break;
		  case 1: unequip(L_HAND); break;
		  case 2: unequip(HEAD);   break;
		  case 3: unequip(BODY);   break;
		}
	 }

	 showEquipped();
	 blitImage(100, curchoice * 8 + 38, &arrow);
  }

  clearArea(100, curchoice * 8 + 38, 16, 16);
}

void menu_equip(void)
{
  window(100, 8, 184, 16);
  blitString(116, 12, 15, "Equip");
  blitString(172, 12, 15, "Unequip");
  blitString(244, 12, 15, "Empty");
  blitImage(100, 8, &arrow);

  showEquipped();
  int curChoice = 0;

  int done = 0;
  while (!done)
  {
    showEquipped();
    window(100, 8, 184, 16);
    blitString(116, 12, 15, "Equip");
    blitString(172, 12, 15, "Unequip");
    blitString(244, 12, 15, "Empty");
    switch (curChoice)
    {
      case 0: blitImage(100, 8, &arrow); break;
      case 1: blitImage(156, 8, &arrow); break;
      case 2: blitImage(228, 8, &arrow); break;
    }

    int exec = 0;

    while (keyPressed()) {}
    int key = 0;
    while (!key)
    {
      if (keyTable[LEFTARROW])
        { if (--curChoice == -1) curChoice = 0; key = 1; PlaySound(SOUND_CHOICE); }
      if (keyTable[RIGHTARROW])
        { if (++curChoice == 3)  curChoice = 2; key = 1; PlaySound(SOUND_CHOICE); }
      if (keyTable[ESC])        { done = 1; key = 1; PlaySound(SOUND_SELECT);}
      if (keyTable[ENTER])      { exec = 1; key = 1; PlaySound(SOUND_SELECT);}
    }

    switch (curChoice)
    {
      case 0: clearArea(100, 8, 16, 16); break;
      case 1: clearArea(156, 8, 16, 16); break;
      case 2: clearArea(228, 8, 16, 16); break;
    }

    if (exec)
    {
      switch (curChoice)
      {
        case 0: equip_part(); break;
        case 1: unequip_part(); break;
        case 2: unequip(R_HAND); unequip(L_HAND);
                unequip(HEAD);   unequip(BODY);
      }
    }

    switch (curChoice)
    {
      case 0: blitImage(100, 8, &arrow); break;
      case 1: blitImage(156, 8, &arrow); break;
      case 2: blitImage(228, 8, &arrow); break;
    }
  }

  switch (curChoice)
  {
    case 0: clearArea(100, 8, 16, 16); break;
    case 1: clearArea(156, 8, 16, 16); break;
    case 2: clearArea(228, 8, 16, 16); break;
  }
}

void menu_status(void)
{
  window(100, 8, 100, 156);
  blitString(102, 10, 15, player.name);

  sprintf(string, "Level: %d", player.level + 1);
  blitString(102, 18, 15, string);

  sprintf(string, "Exp:  %d", player.exp);
  blitString(102, 26, 15, string);

  sprintf(string, "Next: %ld", (player.level == MAX_LEVEL - 1) ? 0 :
          gamedata.levelTable[player.level + 1] - player.exp);
  blitString(102, 34, 15, string);

  blitString(102,         50, 15, "HP:");
  sprintf(string, "%d", player.HP);
  blitString(102 + 8 * 4, 50, 15, string);
  blitChar(102 + 8 * 8,   50, 15, '/');
  sprintf(string, "%d", player.maxHP);
  blitString(102 + 8 * 9, 50, 15, string);

  blitString(102,         66, 15, "MP:");
  sprintf(string, "%d", player.MP);
  blitString(102 + 8 * 4, 66, 15, string);
  blitChar(102 + 8 * 8,   66, 15, '/');
  sprintf(string, "%d", player.maxMP);
  blitString(102 + 8 * 9, 66, 15, string);

  sprintf(string, "Gold: %d", player.gold);
  blitString(102, 82, 15, string);

  sprintf(string, "Str: %d", player.strength);
  blitString(102, 98, 15, string);
  sprintf(string, "Spd: %d", player.speed);
  blitString(102, 106, 15, string);
  sprintf(string, "Wis: %d", player.wisdom);
  blitString(102, 114, 15, string);

  sprintf(string, "Att: %d", player.attack());
  blitString(102, 130, 15, string);
  sprintf(string, "Mag: %d", player.mpower());
  blitString(102, 138, 15, string);
  sprintf(string, "Def: %d", player.defense());
  blitString(102, 146, 15, string);
  sprintf(string, "MDf: %d", player.mdef());
  blitString(102, 154, 15, string);

  while (keyPressed()) {}
  while (!keyPressed()) {}
}

void drawMainMenu(void)
{
  blitScreen(mainbuf);
  window(6, 8, 40, 12);
  blitString(10, 10, 15, "Menu");

  window(6, 30, 72, 48);
  blitString(26, 34, 15, "Items");
  blitString(26, 42, 15, "Equip");
  blitString(26, 50, 15, "Status");
  blitString(26, 58, 15, "Save");
  blitString(26, 66, 15, "Quit");
}

void menu(int where)
{
  byte far *oldBuf = curBuf;
  curBuf = screen;

  drawMainMenu();
  blitImage(6, 30, &arrow);

  int choice = 0, oldchoice = 0;

  int done = 0;
  while (!done)
  {
    if (oldchoice != choice) PlaySound(SOUND_CHOICE);
    oldchoice = choice;

    int exec = 0;

    while (keyPressed()) {}
    int key = 0;
    while (!key)
    {
      if (keyTable[UPARROW])   { if (--choice == -1) choice = 4; key = 1; }
      if (keyTable[DOWNARROW]) { if (++choice == 5)  choice = 0; key = 1; }
      if (keyTable[ENTER])     { exec = 1;                       key = 1; }
      if (keyTable[ESC])       { done = 1;                       key = 1; }
    }

    if (exec || done) PlaySound(SOUND_SELECT);

    clearArea(6, oldchoice * 8 + 30, 16, 16, 0);
    blitImage(6, choice * 8 + 30, &arrow);

    if (exec)
    {
      clearArea(6, choice * 8 + 30, 16, 16, 0);

      switch (choice)
      {
        case 0: menu_items();  break;
        case 1: menu_equip();  break;
        case 2: menu_status(); break;
        case 3:
          if (where) // If in a town
            talkMessage("CAN'T SAVE HERE! ");
          else
          {
            FILE *handle = fopen(SAVEGAME_FILE, "wb");
            fwrite(&player, 1, sizeof(playerType), handle);
            fwrite(gamedata.items, 1, sizeof(gamedata.items), handle);
            fwrite(&mapx, 1, sizeof(mapx), handle);
            fwrite(&mapy, 1, sizeof(mapy), handle);
            fclose(handle);
          }
          break;
        case 4: gamestatus = MENU_QUIT; return;
      }

      drawMainMenu();
      blitImage(6, choice * 8 + 30, &arrow);
      exec = 0;
    }
  }

  clearArea(6, oldchoice * 8 + 30, 16, 16, 0);
  curBuf = oldBuf;
  blitScreen(oldBuf);
  while (keyPressed()) {}
}
